package orderprocessing;

import java.io.*;
import java.util.*;

public class InventoryMaintenance
{	public static void main(String [] args)
	{	OrderProcessor.open();
		System.out.println("Inventory Maintenance");
		BufferedReader in = null;
		String command = null;
		try
		{	in = new BufferedReader(new FileReader(args[0]));
		}
		catch (IOException e)
		{	System.out.println("Failed opening inventory maintenance file.");
			System.out.flush();
			try{System.in.read();System.in.read();} catch (IOException io){}
			System.exit(1);
		}
		try
		{	while ((command = in.readLine()) != null)
			{	if(command.equals("")) continue;
				StringTokenizer tokens = new StringTokenizer(command);
				String operation = tokens.nextToken();
				System.out.println(operation);
				String idNum = null;
				int quantity = 0;
				InventoryManager.InventoryItem invItem = null;
				if(operation.equals("add"))
				{	idNum= tokens.nextToken();
					quantity = Integer.parseInt(tokens.nextToken());
					Product product = Product.get(idNum);
					if( product != null)
					{	InventoryManager.newInventoryItem(product, quantity);
						System.out.println("Item added " + idNum);
					}
					else
						System.out.println("No such product " + idNum);
				}
				else if (operation.equals("increment"))
				{	idNum= tokens.nextToken();
					quantity = Integer.parseInt(tokens.nextToken());
					invItem = InventoryManager.standardInventoryManager.get(idNum);
					if( invItem != null)
					{	invItem.increment(quantity);
						System.out.println("Item " + idNum +" incremented by " + quantity);
					}
					else
						System.out.println("No such inventory item " + idNum);
				}
				else if (operation.equals("display"))
				{	idNum= tokens.nextToken();
					//invItem = (InventoryItem)allInventory.get(idNum);
					//System.out.println(invItem);
					InventoryManager.display(idNum);
				}
				else if (operation.equals("displayall"))
				{	//System.out.println(allInventory);
					InventoryManager.displayAll();
				}
				
			}
		}
		catch(IOException io)
		{	System.out.println("Failed reading inventory maintenance file.");
			System.out.flush();
			try{System.in.read();System.in.read();} catch (IOException e){}
			System.exit(1);
		}
		System.out.println("All done");
		try{System.in.read();System.in.read();} catch (IOException e){}
		OrderProcessor.close();
	}
}