package orderprocessing;

import java.text.*;
import java.util.*;
import java.io.*;

public class Price implements SortableObject,  Serializable, Cloneable, Versionable 
{   public Price(CalculationCalendar date) 
    {   this.date = date;
			this.unitPrice = 0;
	}
   public Price(CalculationCalendar date, double price) 
   {    this.date = date;
			this.unitPrice = price;
	}
	public CalculationCalendar date() { return date; }
	public double price() { return unitPrice; }
	public void display() {	System.out.println(toString()); }
	public Object clone() { return new Price(date, unitPrice); }
	public Object newVersion(Object information){return null; }
	
	public String toString(){
        Date d = date.getTime();
        SimpleDateFormat sd = new SimpleDateFormat("MM/dd/yyyy");
        String s = sd.format(d);
        return s + "\t" + unitPrice;
    }
    public void modify(double price) { this.unitPrice = price; }
    public boolean equals(SortableObject o) {
        if (!(o instanceof Price)) return false;
        Price oi = (Price)o;
        return date.equals(oi.date());
    }
    public boolean greater(SortableObject o) {
        if (!(o instanceof Price)) return false;
        Price oi = (Price)o;
        return date.getTime().after(oi.date().getTime());
    }
	private CalculationCalendar date;
	private double unitPrice;
}


