package orderprocessing;

import java.util.*;
import java.text.*;
import java.io.*;

public class ProductMaintenance // All static methods
{  //The input command functions (for phase 0.2 only) starts from here
  public static void main (String argv[])
  {
    System.out.println( "\n \nPACE Product Inc.! By Team2\n \n" );
    batchInput(argv[0]);
    try {System.in.read();}catch(IOException e){}
  }

  public static void batchInput(String fileName)
  { try {
        FileReader inputFile = new FileReader(fileName);
        BufferedReader reader = new BufferedReader(inputFile);
        String line;
        open();
        while ( (line = reader.readLine())!=null) {
            System.out.println("  \n"+line);
            StringReader in = new StringReader(line);
            StreamTokenizer tokens = new StreamTokenizer(in);
            tokens.eolIsSignificant(true);
            tokens.quoteChar(QUOTE_CHAR);
            if (tokens.nextToken() == tokens.TT_WORD) commandLine(tokens);
        }
        inputFile.close();
        close();
    } catch(IOException e) {
        System.out.println( "IO error in main()!" );
    }
  }

  private static void commandLine(StreamTokenizer tokens)
  {	String name = null; CalculationCalendar date = null;
    String id = null; double price = 0;

    if (tokens.sval.equals("Unit-Price"))
    {    id = getID(tokens);
        date = getDate(tokens);
        if (!(date instanceof CalculationCalendar)) {
            System.out.println("Date field error!");
            return;
        }
        if ( id == null) {
            System.out.println("ID field Error!");
            return;
        }
        price = unitPrice(id,date);
        SimpleDateFormat sd = new SimpleDateFormat("MM/dd/yyyy");
        String s = sd.format(date.getTime());
        if ( price >= 0 )
            System.out.println("Unit Price\t"+id+"\t"+s+"\t"+price);
        else
            System.out.println("Unit Price\t"+id+"\t"+s+"\t No Sales Price.");
    }else if (tokens.sval.equals("Add-Item")){
        name = getName(tokens);
        date = getDate(tokens);
        price = getPrice(tokens);
        if (!(name instanceof String)) {
            System.out.println("Name field error! "+ name);
            return;
        }
        if (!(date instanceof CalculationCalendar)) {
            System.out.println("Date field error!" + date);
            return;
        }
        if ( price <= 0 ) {
            System.out.println("Price field error!");
            return;
        }
        add( name, date, price );
        System.out.println("Item :"+name+" has been added to the system.");
    }else if (tokens.sval.equals("Del-Item")){
        id = getID(tokens);
        if ( id == null ) {
            System.out.println("ID field error!");
            return;
        }
        if (remove(id) != null)
            System.out.println("\nItem is not in the list!");
        else
            System.out.println("OK!");
    }else if (tokens.sval.equals("Mod-Item")){
        id = getID(tokens);
        name = getName(tokens);
        if (!(name instanceof String)) {
            System.out.println("Name field error!");
            return;
        }
        if ( id == null ) {
            System.out.println("ID field error!");
            return;
        }
        if ( !modify(id, name) )
            System.out.println("\nItem is not in the list!");
        else
            System.out.println("OK!");
    }else if (tokens.sval.equals("Add-Price")){
         id = getID(tokens);
         date = getDate(tokens);
         price = getPrice(tokens);
         if (!(date instanceof CalculationCalendar)) {
             System.out.println("Date field error!");
             return;
         }
         if ( price <= 0 ) {
             System.out.println("Price field error!");
             return;
         }
         if ( id == null ) {
             System.out.println("ID field error!");
             return;
         }
         if (!addPrice( id, date, price ))
             System.out.println("This price is in the list already!");
         else
             System.out.println("OK!");
     }else if (tokens.sval.equals("Del-Price")){
         id = getID(tokens);
         date = getDate(tokens);
         if (!(date instanceof CalculationCalendar)) {
             System.out.println("Date field error!");
             return;
         }
         if ( id == null ) {
             System.out.println("ID field error!");
             return;
         }
         if (!deletePrice( id, date ))
             System.out.println("This price is not in the list!");
         else
             System.out.println("OK!");
     }else if (tokens.sval.equals("Mod-Price")){
         id = getID(tokens);
         date = getDate(tokens);
         price = getPrice(tokens);
         if (!(date instanceof CalculationCalendar)) {
             System.out.println("Date field error!");
             return;
         }
         if ( price <= 0 ) {
             System.out.println("Price field error!");
             return;
         }
         if ( id == null ) {
             System.out.println("ID field error!");
             return;
         }
         if (!modifyPrice( id, date, price ))
             System.out.println("This Dated-Price is not in the list!");
         else
             System.out.println("OK!");
     }else if (tokens.sval.equals("Item-Report")){
         id = getID(tokens);
         if ( id == null ) {
             System.out.println("ID field error!");
             return;
         }
         itemReport(id);
         System.out.println("OK!");
     }else if (tokens.sval.equals("Full-Report")){
         productReport();
         System.out.println("OK!");
     }else return;
  }

  private static void open()
  {  OrderProcessor.open();
  }

  private static void close()
  { OrderProcessor.close();
  }
  // End of the Input commands functions (for phase 0.2 only)

  public static final Product remove(String itemNumber)
  {  return Product.remove(itemNumber);
  }

  public static final void add (String description, CalculationCalendar date, double price ) 
  {  Product o = new Product(description, date, price);
  }

  public static final boolean modify (String itemNumber, String description) {
    Product i = Product.get(itemNumber);
    if ( i instanceof Product) {
        i.modify(description);
        return true;
    } else
        return false;
  }

  public static final double unitPrice (String itemNumber, CalculationCalendar date) 
  { Product i = Product.get(itemNumber);
    if ( i instanceof Product) {
        return i.unitPrice(date);
    } else
        return -1;
  }

  public static final boolean addPrice (String itemNumber, CalculationCalendar date, double price) 
  {  Product i = Product.get(itemNumber);
    if ( i instanceof Product) 
    {    i.addPrice(date, price);
        return true;
    } else
        return false;
  }

  public static final boolean deletePrice (String itemNumber, CalculationCalendar date) {
     Product i = Product.get(itemNumber);
    if ( i instanceof Product)
        return i.deletePrice(date);
    else
        return false;
  }

  public static final boolean modifyPrice (String itemNumber, CalculationCalendar date, double price) {
    Product i = Product.get(itemNumber);
    if ( i instanceof Product ){
        return i.modifyPrice(date, price);
    }else
        return false;
  }

  public static final void itemReport(String itemNumber) 
  {   System.out.println( "\n \nItem Report of PACE Inc. By Team2\n \n" );
      Product i = Product.get(itemNumber);
      if ( i instanceof Product) 
      {  System.out.println(i);
      }
  }

  public static final void productReport() 
  {    System.out.println( "\n \nProduct Report of PACE Product Inc. By Team2\n \n" );
      Enumeration e = Product.elements();
      while(e.hasMoreElements())
         System.out.println(e.nextElement());
  }
  
// file parsing functions------------------------------------------
// Note that this uses a STREAM tokenizer not the STRING tokenizer used elsewhere.

  private static boolean getLabel(String label, StreamTokenizer tokens)
  { try {
        int i;
       if ((i = tokens.nextToken())!= tokens.TT_WORD) return false;
        if (!tokens.sval.equals(label)) return false;
     if ((i = tokens.nextToken())!= FIELD_TOKEN) return false;
        return true;
    } catch(IOException e) {
        System.out.println( "IO error in getLabel()!" );
        return false;
    }
  }

  private static String getID(StreamTokenizer tokens)
  {		int i;
        if (!getLabel("ID",tokens)) return null;
        return tokens.sval;
  }

  private static String getName(StreamTokenizer tokens)
  { try {
        int i;
        if (!getLabel("Name",tokens)) return null;
       if ((i = tokens.nextToken())!= QUOTE_CHAR) return null;
        return tokens.sval;
    } catch(IOException e) {
        System.out.println( "IO error in getName()!" );
        return null;
    }
  }

  private static CalculationCalendar getDate(StreamTokenizer tokens)
  { try {
        int i;
        if (!getLabel("Date",tokens)) return null;
        if ((i = tokens.nextToken())!= QUOTE_CHAR) return null;
        CalculationCalendar date = new CalculationCalendar();
        SimpleDateFormat sd = new SimpleDateFormat("MMM/dd/yyyy");
        date.setTime(sd.parse(tokens.sval));
        return date;
    } catch(IOException e) {
        System.out.println( "IO error in getDate()!" );
        return null;
     } catch (ParseException pe) {
        System.out.println("Illegal date value");
        return null;
     }
  }

  private static double getPrice(StreamTokenizer tokens)
  { try {
        int i;
        if (!getLabel("Price",tokens)) return 0;
        if ((i = tokens.nextToken())!= tokens.TT_NUMBER) return 0;
        return tokens.nval;
    } catch(IOException e) {
        System.out.println( "IO error in getPrice()!" );
        return 0;
    }
  }
  private static final char QUOTE_CHAR = '"';
  private static final char FIELD_TOKEN = ':';

}


