package orderprocessing;

import java.text.*;
import java.util.*;
import java.io.*;

public class SortedList extends Vector implements CollectionsInterface
{
  public boolean remove(SortableObject o) {
     if (!(o instanceof SortableObject)) return false;
     int i = binarySearch(o);
     if ( i < size() ) {
        Object e = elementAt(i);
        if (o.equals(e)) {
            removeElementAt(i);
            return true;
        } else
            return false;
     } else
            return false;
  }
  public boolean add (SortableObject o) {
     if (!(o instanceof SortableObject)) return false;
     int i = binarySearch(o);
     if ( i < size() ) {
        Object e = elementAt(i);
        if (o.equals(e)) return false;
     }
     insertElementAt(o,i);
     return true;
  }
  public int binarySearch (SortableObject o) {
    if (!(o instanceof SortableObject)) return 0;
    int i = 0, first = 0, last = size();
    if (last == 0) return 0;
    SortableObject n = (SortableObject)firstElement();
    SortableObject m = (SortableObject)lastElement();
    while ( m != n ){
      i = ( first + last ) / 2;
      m = n;
      n = (SortableObject)elementAt(i);
      if(o.equals(n)) return i;
      if ( o.greater(n) ) first = i+1;
      else last = i;
    }
    if (o.greater(n))
       return i + 1;
    else return i;
  }
  public SortableObject search(SortableObject o) {
     if (!(o instanceof SortableObject)) return null;
     int i = binarySearch(o);
     if ( i < size() ) {
        SortableObject e = (SortableObject)elementAt(i);
        if (o.equals(e))
            return e;
        else
            return null;
     } else
            return null;
  }
}

